<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFlayerCardForSeatMap ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfFlayerCardForSeatMap extends AbstractStructArrayBase
{
    /**
     * The FlayerCardForSeatMap
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \dgsoft\StructType\DgFlayerCardForSeatMap[]
     */
    public $FlayerCardForSeatMap;
    /**
     * Constructor method for ArrayOfFlayerCardForSeatMap
     * @uses DgArrayOfFlayerCardForSeatMap::setFlayerCardForSeatMap()
     * @param \dgsoft\StructType\DgFlayerCardForSeatMap[] $flayerCardForSeatMap
     */
    public function __construct(array $flayerCardForSeatMap = array())
    {
        $this
            ->setFlayerCardForSeatMap($flayerCardForSeatMap);
    }
    /**
     * Get FlayerCardForSeatMap value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \dgsoft\StructType\DgFlayerCardForSeatMap[]|null
     */
    public function getFlayerCardForSeatMap()
    {
        return isset($this->FlayerCardForSeatMap) ? $this->FlayerCardForSeatMap : null;
    }
    /**
     * Set FlayerCardForSeatMap value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgFlayerCardForSeatMap[] $flayerCardForSeatMap
     * @return \dgsoft\ArrayType\DgArrayOfFlayerCardForSeatMap
     */
    public function setFlayerCardForSeatMap(array $flayerCardForSeatMap = array())
    {
        foreach ($flayerCardForSeatMap as $arrayOfFlayerCardForSeatMapFlayerCardForSeatMapItem) {
            // validation for constraint: itemType
            if (!$arrayOfFlayerCardForSeatMapFlayerCardForSeatMapItem instanceof \dgsoft\StructType\DgFlayerCardForSeatMap) {
                throw new \InvalidArgumentException(sprintf('The FlayerCardForSeatMap property can only contain items of \dgsoft\StructType\DgFlayerCardForSeatMap, "%s" given', is_object($arrayOfFlayerCardForSeatMapFlayerCardForSeatMapItem) ? get_class($arrayOfFlayerCardForSeatMapFlayerCardForSeatMapItem) : gettype($arrayOfFlayerCardForSeatMapFlayerCardForSeatMapItem)), __LINE__);
            }
        }
        if (is_null($flayerCardForSeatMap) || (is_array($flayerCardForSeatMap) && empty($flayerCardForSeatMap))) {
            unset($this->FlayerCardForSeatMap);
        } else {
            $this->FlayerCardForSeatMap = $flayerCardForSeatMap;
        }
        return $this;
    }
    /**
     * Add item to FlayerCardForSeatMap value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgFlayerCardForSeatMap $item
     * @return \dgsoft\ArrayType\DgArrayOfFlayerCardForSeatMap
     */
    public function addToFlayerCardForSeatMap(\dgsoft\StructType\DgFlayerCardForSeatMap $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgFlayerCardForSeatMap) {
            throw new \InvalidArgumentException(sprintf('The FlayerCardForSeatMap property can only contain items of \dgsoft\StructType\DgFlayerCardForSeatMap, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->FlayerCardForSeatMap[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgFlayerCardForSeatMap|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgFlayerCardForSeatMap|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgFlayerCardForSeatMap|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgFlayerCardForSeatMap|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgFlayerCardForSeatMap|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FlayerCardForSeatMap
     */
    public function getAttributeName()
    {
        return 'FlayerCardForSeatMap';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfFlayerCardForSeatMap
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
